require 'socket'
require 'thread'

Thread.abort_on_exception = true

# ѥ᡼
port = if ARGV[0] then ARGV[0] else 12345 end

# ­®襵
class SumRace

  # 㳰Τ
  class NewQuestion  < StandardError; end
  class ResultReport < StandardError; end

  # ѥ᡼
  T_limit = 10
  Q_length = 5
  Q_change = 3

  # 
  def initialize(port)
    srand
    @port = port
    @client_list = []
    @m_clnts = Mutex.new
    @ans_queue = Queue.new
  end

  # ʲϥץ饤١ȥ᥽å
  private

  # 
  def gen_question(length)
    num = rand(9) + 1
    correct = num
    question = num.to_s
    (2..length).each {
      num = rand(9) + 1
      correct += num
      question += " + #{num}"
    }
    return correct, question
  end

  # ꥹå
  def send_Q_loop(sock)
    loop do
      # Ԥ
      sock.write "Please wait ...\n"
      begin
        Thread.stop
      rescue NewQuestion
        sock.write $!
      rescue ResultReport
        retry
      end

      # ȥ -- Ԥ
      begin
        cnt = T_limit
        while cnt > 0
          sock.write('.' * cnt + "\n")
          sleep 1
          cnt = cnt - 1
        end
        Thread.stop
      rescue NewQuestion
        sock.write $!
        retry
      rescue ResultReport
        sock.write $!
        next
      end
    end
  end

  # 饤Ͽ
  def start_client(sock)
    # ꥹåɤ
    th_write = Thread.start{
      send_Q_loop(sock)
    }

    # åɤγ
    th_read = Thread.start {
      peer = sock.peeraddr.inspect
      while msg = sock.gets
        num, ans = msg.split(':')
        @ans_queue.enq([num.to_i, ans.to_i, th_write])
      end
      STDERR.print "DEL: #{peer}\n"
      th_write.kill if th_write.alive?
      sock.close unless sock.closed?
    }

    # 饤ɲ
    @m_clnts.synchronize {
      STDERR.print "ADD: #{sock.peeraddr.inspect}\n"
      @client_list << th_write
      @q_thread.run
    }
  end

  def gen_Q_thread
    # ȷ̽
    Thread.start {
      clients = nil
      q_id = -1
      loop do
        @m_clnts.synchronize {
          clients = @client_list.dup
        }
        if clients.size == 0
          Thread.stop # 饤ȤϿޤ
          next
        end
        if q_id < 9999 then q_id += 1 else q_id = 0 end
        answer, question = gen_question(Q_length + rand(Q_change))
        clients.each{|clnt|
          begin
            clnt.raise NewQuestion, 
                       format("#%04d: %s\n", q_id, question)
          rescue ThreadError
          end
        }

        # Ԥ
        (1..T_limit).each {
          sleep 1
        }

        # ڤ
        ans_total = @ans_queue.length

        # å
        participants = clients.size
        order = 0
        results = Array.new(participants, nil)
        (1..ans_total).each do
          ans_id, ans, clnt = @ans_queue.deq
          next if ans_id != q_id  # оݤǤʤ̵
          if (idx = clients.index(clnt)) && !results[idx]
            # ¸ߤ륯饤Ȥ̤
            if ans == answer
              # 
              order += 1
              results[idx] = 'Right Answer is ' + answer.to_s + 
                  '. You are #' + order.to_s + ' in ' + 
                  participants.to_s + " participants.\n"
            else
              # 
              results[idx] = 'Right Answer is ' + answer.to_s + 
                  ". You couldn't give the right answer.\n"
            end
          end
        end

        # ̤Υݡ
        clients.each_with_index{|clnt, idx|
          begin
            if results[idx]
              clnt.raise ResultReport, results[idx]
            else
              clnt.raise(ResultReport, 
                         'No Answer!! Right Answer is ' + 
                         answer.to_s + ". \n")
            end
          rescue ThreadError
          end
        }

        # 饤ȤδλԤ
        begin
          not_ready = 0
          clients.each{|clnt|
            if not clnt.alive?
              @m_clnts.synchronize {
                @client_list.delete clnt
              }
            elsif clnt.status == 'run'
              not_ready += 1
            end
          }
        end until not_ready == 0
      end
    }
  end

  # ᥤ롼
  def run
    # ꥹåɤ
    @q_thread = gen_Q_thread

    # 饤ȼ
    gate = TCPServer.open(@port)
    loop do
      sock = gate.accept
      start_client(sock)
      @q_thread.run
    end
  end
  public :run
end

# г
SumRace.new(port).run
